CLEAR
SET SAFETY OFF

LOCAL cBuf, nRetVal, nSockError, nData, nSockHandler, nSize
LOCAL cHosten, cIP_ptrptr, cAddr_ptr, nIP
PUBLIC nRecvBufferSize

#DEFINE WSADATA_SIZE 398
#DEFINE WS_VERSION   514    &&  0x0202 

#DEFINE AF_INET         2  && internetwork: UDP, TCP, etc. 
#DEFINE SOCK_STREAM     1
#DEFINE IPPROTO_TCP     6
#DEFINE SOL_SOCKET      0xFFFF  &&     (socket level options)
#DEFINE SO_RCVBUF       0x1002  &&     
#DEFINE HOSTENT_SIZE 16 &&   hostent
#DEFINE CRLF             CHR(13)+CHR(10)

#DEFINE SD_SEND          1
#DEFINE MSG_PEEK         2   &&   ,     
#DEFINE MSG_WAITALL      8   && ,     

#DEFINE SOCKET_ERROR    -1

DECLARE integer WSAStartup IN ws2_32.dll short, string @
DECLARE integer WSACleanup IN ws2_32.dll
DECLARE integer WSAGetLastError IN ws2_32.dll
DECLARE integer socket IN ws2_32.dll integer, integer, integer
DECLARE integer closesocket IN ws2_32.dll integer
DECLARE integer connect IN ws2_32.dll integer, string @, integer
DECLARE integer gethostbyname IN ws2_32.dll string @
DECLARE integer shutdown IN ws2_32.dll integer, integer
DECLARE integer send IN ws2_32.dll integer, string @, integer, integer
DECLARE integer getsockopt IN ws2_32.dll integer, integer, integer, string @, integer @
DECLARE integer recv IN ws2_32.dll integer, string @, integer, integer

*     Winsock
cBuf = REPLICATE(CHR(0),WSADATA_SIZE)
nRetVal = WSAStartup(WS_VERSION,@cBuf)
IF nRetVal <> 0
	Error_Winsock()
	RETURN
ENDIF

?': '+LTRIM(STR(CTOBIN(CREATEBINARY(SUBSTR(cBuf,2,1)),'1S')))+'.'+;
				LTRIM(STR(CTOBIN(CREATEBINARY(SUBSTR(cBuf,1,1)),'1S')))
?': '+SUBSTR(cBuf,5,AT(CHR(0),cBuf)-5)

*  Socket
nSockHandler = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)
IF nSockHandler = 0
	Error_Winsock()
	WinSock_Free()
	RETURN
ELSE
	?nSockHandler 
	cBuf = REPLICATE(CHR(0),4)
	nSize = 4
	nRetVal = getsockopt(nSockHandler,SOL_SOCKET,SO_RCVBUF,@cBuf,@nSize)
	IF nRetVal = SOCKET_ERROR
		Error_Winsock()
		WinSock_Free()
		RETURN
	ENDIF
	?nSize
	nRecvBufferSize = CTOBIN(CREATEBINARY(SUBSTR(cBuf,1,nSize)),TRANSFORM(nSize)+'RS')
	?nRecvBufferSize
	IF nRecvBufferSize <=0
		WinSock_Free()
		RETURN
	ENDIF
ENDIF

cHosten = SYS(2600, gethostbyname("pop3.aaa.ru"), 16)	&&   hostent
cIP_ptrptr = CTOBIN(CREATEBINARY(SUBSTR(cHosten,13,4)),'4RS')	&&    
cAddr_ptr = CTOBIN(CREATEBINARY(SYS(2600, cIP_ptrptr, 4)),'4RS')  &&   
nIP = SYS(2600, cAddr_ptr, 4)

* STRTOFILE(nIP,'file.bin')
*?inet_ntoa(CTOBIN(CREATEBINARY(nIP),'RS'))

* STRTOFILE(BINTOC(110,'2SR'),'file.bin')

* inet_ntoa
cBuf = BINTOC(AF_INET,'2SR') + BINTOC(110,'2S') + nIP + REPLICATE(CHR(0),8)

* 
nRetVal = connect(nSockHandler, @cBuf, LEN(cBuf))
IF nRetVal <> 0
	Error_Winsock()
	WinSock_Free()
	RETURN
ENDIF

= data_recv(nSockHandler, @cBuf)
?cBuf
data_send(nSockHandler, 'USER user'+CRLF)
= data_recv(nSockHandler, @cBuf)
?cBuf
data_send(nSockHandler, 'PASS pass'+CRLF)
= data_recv(nSockHandler, @cBuf)
?cBuf
data_send(nSockHandler, 'RETR 20'+CRLF)

cResult = ''
nCount = nRecvBufferSize
DO WHILE nCount = nRecvBufferSize
	cBuf = ''
	nCount = data_recv(nSockHandler, @cBuf)
*	?nCount
	cResult = cResult + cBuf
ENDDO
STRTOFILE(cResult,'mail.txt')

* SET STEP ON 

* 
nRetVal = shutdown(nSockHandler, SD_SEND)
IF nRetVal <> 0
	Error_Winsock()
ENDIF

*  Socket
nRetVal = closesocket(nSockHandler)
IF nRetVal <> 0
	Error_Winsock()
	WinSock_Free()
	RETURN
ENDIF

*  Winsock
WinSock_Free()

FUNCTION Error_Winsock
	nSockError = WSAGetLastError()
	MESSAGEBOX(' Winsock  '+LTRIM(STR(nSockError))+'.'+CHR(13)+CHR(10)+'   MSDN  Windows Sockets Error Codes.',16,'!')
ENDFUNC

FUNCTION WinSock_Free
nRetVal = WSACleanup()
IF nRetVal <> 0
	Error_Winsock()
ENDIF
ENDFUNC

FUNCTION data_send (nSockHandler, cData)
LOCAL nRetVal
	nRetVal = send(nSockHandler, @cData, LEN(cData), 0)
	IF nRetVal = SOCKET_ERROR
		Error_Winsock()
		WinSock_Free()
		CANCEL
	ELSE
		?" "+TRANSFORM(nRetVal)+" "
	ENDIF
ENDFUNC

FUNCTION data_recv(nSockHandler, cBuf)
LOCAL cData
	cData = SPACE(nRecvBufferSize)
	nRetVal = recv(nSockHandler, @cData, LEN(cData), 0)
	IF nRetVal = SOCKET_ERROR
		Error_Winsock()
		WinSock_Free()
		CANCEL
	ELSE
		?" "+TRANSFORM(nRetVal)+" "
	ENDIF
	cBuf = LEFT(cData, nRetval)
	RETURN nRetVal
ENDFUNC
